#version 460

uniform sampler2D gtexture;
uniform sampler2D lightmap;
uniform sampler2D normals;
uniform sampler2D specular;
uniform sampler2D shadow;
uniform sampler2D watershadow;
uniform sampler2D noisetex;
uniform sampler2D shadowcolor;

uniform mat4 gbufferModelViewInverse;
uniform vec3 cameraPosition;
uniform vec3 shadowLightPosition;

/* DRAWBUFFERS:0 */

layout(location = 0) out vec4 outColor0;

in vec2 texCoord;
in vec3 foliageColor;
in vec2 lightMapCoords;
in vec3 geoNormal;

uniform int worldTime;

void main() {

    vec3 shadowLightDirection = normalize(mat3(gbufferModelViewInverse) * shadowLightPosition);

    vec3 worldGeoNormal = geoNormal * mat3(gbufferModelViewInverse);

    float lightBrightness = clamp(dot(shadowLightDirection,worldGeoNormal),0.2,1.0);

    //- (texture(gtexture,lightMapCoords).rgb)
    vec3 lightColor = pow(texture(lightmap, lightMapCoords).rgb  , vec3(2.3));

    vec4 outputColorData = pow( texture(gtexture, texCoord) , vec4(3.3));
    vec3 outputColor = outputColorData.rgb * pow(foliageColor, vec3(3.3)) * lightColor;
    float transparency = outputColorData.a;
    if(transparency < 0.3){
        discard;
    }
    outputColor *= lightBrightness;

    outColor0 = vec4(pow(outputColor,vec3(1/2.3)),transparency);
}  