#include "basic_vert.glsl"
uniform vec3 chunkOffset;


out vec3 geoNormal;

void main() {

    geoNormal = vaNormal * normalMatrix;
    texCoord = vaUV0;
    foliageColor = vaColor.rgb;
    lightMapCoords = vaUV2 *(1.0 / 256.0) + (1.0 / 32.0);

    vec3 worldSpaceVertexPosition = cameraPosition + (gbufferModelViewInverse * modelViewMatrix * vec4(vaPosition + chunkOffset,1)).xyz;

    float distanceFromCamera = distance(worldSpaceVertexPosition, cameraPosition);

    gl_Position =  projectionMatrix * modelViewMatrix * vec4(vaPosition + chunkOffset -  distanceFromCamera * Curvature,1);
}